/* +------------------------------------------------------------------------+
   |                                                                        |
   |                          Addition/soustraction                         |
   |                                                                        |
   +------------------------------------------------------------------------+ */

#include "defs.h"

/* c <- a + b, retourne la retenue */
ndouble add(ndouble *c, ndouble *a, ndouble *b, int la, int lb) {
  int i;
  ndouble r;

  if (la < lb) {ndouble *x; int l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
  for (i=0,r=0; i < lb; i++,a++,b++,c++) {r += a[0] + b[0]; c[0] = r & mask; r >>= shift;}
  for (;        i < la; i++,a++,    c++) {r += a[0];        c[0] = r & mask; r >>= shift;}
  return(r);
}

/* c <- a - b, retourne la retenue */
zdouble sub(ndouble *c, ndouble *a, ndouble *b, int la, int lb) {
  int i;
  zdouble r;

  for (i=0,r=0; i < lb; i++,a++,b++,c++) {r += a[0] - b[0]; c[0] = r & mask; r >>= shift;}
  for (;        i < la; i++,a++,    c++) {r += a[0];        c[0] = r & mask; r >>= shift;}
  return(r);
}

/* a <- a+b, retourne la retenue */
ndouble inc(ndouble *a, ndouble *b, int la, int lb) {
  int i;
  ndouble r;

  for (i=0,r=0; i < lb;   i++,a++,b++) {r += a[0] + b[0]; a[0] = r & mask; r >>= shift;}
  for (; (r) && (i < la); i++,a++)     {r += a[0];        a[0] = r & mask; r >>= shift;}
  return(r);
}

/* a <- a - b, retourne la retenue */
zdouble dec(ndouble *a, ndouble *b, int la, int lb) {
  int i;
  zdouble r;

  for (i=0,r=0; i < lb;   i++,a++,b++) {r += a[0] - b[0]; a[0] = r & mask; r >>= shift;}
  for (; (r) && (i < la); i++,a++)     {r += a[0];        a[0] = r & mask; r >>= shift;}
  return(r);
}

/* c <- |a-b|, retourne le signe */
int asub(ndouble *c, ndouble *a, ndouble *b, int la, int lb) {
  int i, lc = (la > lb) ? la : lb;
  zdouble r;
  int s;

  for (; (la > lb) && (a[la-1] == 0); la--);
  for (; (lb > la) && (b[lb-1] == 0); lb--);
  if (la == lb) for (; (la > 0) && (a[la-1] == b[lb-1]); la--,lb--);
  s = (la < lb) || ((la == lb) && (la > 0) && (a[la-1] < b[lb-1]));
  if (s) {ndouble *x; int l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
 
  for (i=0,r=0; i < lb; i++) {r += a[i] - b[i]; c[i] = r & mask; r >>= shift;}
  for (;        i < la; i++) {r += a[i];        c[i] = r & mask; r >>= shift;}
  clearmem(c+la,lc-la);
  return(s);
}

/* c <- -a */
zdouble neg(ndouble *c, ndouble *a, int n) {
  zdouble r;
  int i;
  for (i=0,r=0; i<n; i++) {r -= a[i]; c[i] = r & mask; r >>= shift;}
  return(r);
}
