/* +------------------------------------------------------------------------+
   |                                                                        |
   |                           Oprations par blocs                         |
   |                                                                        |
   +------------------------------------------------------------------------+ */

#include "defs.h"

/* dcompose un nombre en blocs */
void expand(ndouble *b, ndouble *a, int la, int lb, int n0) {
  int p = (la+n0-1)/n0;
  int i,l;

  clearmem(b,lb*(n0+1));
  for (i=0; i < p; i++) {
    l = (i < p-1) ? n0 : (la-i*n0);
    movemem(b+i*(n0+1), a+i*n0, l);
  }
}

/* regroupe les blocs */
/* ne marche que si chaque bloc est positif */
void compact(ndouble *b, ndouble *a,
             int la, /* nb de blocs       */
             int n0, /* taille des blocs  */
             int n1, /* dcalage          */
             int lb) /* longueur rsultat */
{
  int i,n2,n3;
  ndouble r;

  if (la <= 0) clearmem(b,lb);
  else {
    /* copie le premier bloc */
    n2 = (lb < n0) ? lb : n0;
    movemem(b,a,n2);
    n2 -= n1;
    r = 0;
    
    /* ajoute les blocs suivants */
    for (i=1; i<la; i++) {
      a += n0;
      b += n1;
      lb-= n1;
      r += inc(b,a,n2,n2);
      n3 = (lb < n0) ? lb-n2 : n0-n2;
      if (n3 > 0) r  = add(b+n2,a+n2,&r,n3,1);
      n2+= n3-n1;
    }
  }
}

              /* +-----------------------------------+
                 |  Addition/soustraction par blocs  |
                 +-----------------------------------+ */

/* c <- a + b, la,lb = nb de blocs */
void bloc_add(ndouble *c, ndouble *a, ndouble *b, int la, int lb, int n0) {
  int i;

  if (la < lb) {ndouble *x; int l; x=a; a=b; b=x; l=la; la=lb; lb=l;}
  for (i=0; i < lb; i++, a+=n0, b+=n0, c+=n0) add(c,a,b, n0,n0);
  movemem(c,a, (la-i)*n0);

}    

/* a <- a + b, la,lb = nb de blocs */
void bloc_inc(ndouble *a, ndouble *b, int la, int lb, int n0) {
  int i,l;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++, a+=n0, b+=n0) inc(a,b, n0,n0);
  movemem(a,b, (lb-i)*n0);

}    

/* c <- a - b, la,lb = nb de blocs */
void bloc_sub(ndouble *c, ndouble *a, ndouble *b, int la, int lb, int n0) {
  int i,l;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++, a+=n0, b+=n0, c+=n0) sub(c,a,b, n0,n0);
  movemem(c,a, (la-i)*n0);
  for (; i < lb; i++, b+= n0, c+= n0) neg(c,b,n0);

}    

/* a <- a - b, la,lb = nb de blocs */
void bloc_dec(ndouble *a, ndouble *b, int la, int lb, int n0) {
  int i,l;

  l = (la < lb) ? la : lb;
  for (i=0; i < l; i++, a+=n0, b+=n0) dec(a,b, n0,n0);
  for (; i < lb; i++,   a+=n0, b+=n0) neg(a,b, n0);

}    

    
/* multiplication par blocs en complment  2 */
void bloc_muln2(ndouble *c, ndouble *a, ndouble *b, int n, int n0) {

  int i,j;
  ndouble *buff;

  for (i=0; i < n; i++) {
    for (j=0; j < n; j++) {
      buff = c + ((i > 0) ? 2*(i+n-1)*n0 : 2*j*n0);
      muln2(buff, a+i*n0, b+j*n0, n0);
      if (a[i*n0+n0-1] & msb) dec(buff+n0, b+j*n0, n0,n0);
      if (b[j*n0+n0-1] & msb) dec(buff+n0, a+i*n0, n0,n0);
      if ((i > 0) && (j < n-1)) inc(c+2*(i+j)*n0, buff, 2*n0, 2*n0);
    }
  }
}

