/* +------------------------------------------------------------------------+
   |                                                                        |
   |                             Gestion mmoire                            |
   |                                                                        |
   +------------------------------------------------------------------------+ */

#include "defs.h"

/* allocation/libration */
/* si debug_mem est dfini, on met des marqueurs au dbut et  la fin */
/* du buffer et on contrle leur prsence lors de la libration */
#ifdef debug_mem
ndouble *getmem(int n) {
  ndouble *buff = malloc((n+3)*sizeof(ndouble));
  if (buff == NULL) perror("out of memory");
  buff[0] = 0x12345678; buff[1] = n; buff[n+2] = 0x87654321;
  return(buff+2);
}

void freemem(ndouble *a) {
  if ((a[-2] != 0x12345678) || (a[a[-1]] != 0x87654321)) {
    fprintf(stderr,"buffer overflow\n");
    fflush(stderr);
    exit(1);
  }
  free(a-2);
}

#else
ndouble *getmem(int n) {
  ndouble *buff = malloc(n*sizeof(ndouble));
  if (buff == NULL) {
    fprintf(stderr,"out of memory");
    fflush(stderr);
    exit(1);
  }
  return(buff);
}

void freemem(ndouble *a) {
  free(a);
}
#endif

/* mise  zro */
void clearmem(ndouble *a, int n) {
  if (n > 0) memset(a,0,n*sizeof(ndouble));
}

/* a <- b */
void movemem(ndouble *a, ndouble *b, int n) {
  if (n > 0) memmove(a,b,n*sizeof(ndouble));
}

