/* +------------------------------------------------------------------------+
   |                                                                        |
   |                            Fonctions utilitaires                       |
   |                                                                        |
   +------------------------------------------------------------------------+ */

#include <time.h>
#include <sys/times.h>
#include "defs.h"

/* mesure le temps en milisecondes */
double chrono() {
  struct tms buf;

  times(&buf);
  return((double)(buf.tms_utime + buf.tms_stime)*1000/CLK_TCK);
}

/* affichage hexadcimal */
void dump(ndouble *a, int n) {
  int i;
  for (i=n-1; i >= 0; i--) {
    fprintf(stderr,
#ifdef bits64
            "%08lX",
#else
#ifdef longlong
            "%08llX",
#else
            "%04lX",
#endif
#endif
            a[i]);
  }
  fprintf(stderr,"\n");
}

/* initialisation  partir d'une chane hexadcimale */
ndouble *from_string(char *s, int n) {
  ndouble *a = getmem(n), x;
  int    l = strlen(s), i;

  clearmem(a,n);
  s += l;
  x = ((ndouble)1) << shift;
  i = 0;
  while ((l > 0) && (i < n)) {
    s--; l--;
    if (*s <= '9')      x += ((zdouble)(*s - '0')      << (shift+1));
    else if (*s <= 'F') x += ((zdouble)(*s - 'A' + 10) << (shift+1));
    else                x += ((zdouble)(*s - 'a' + 10) << (shift+1));
    x >>= 4;
    if (x&1) {a[i++] = x >> 1; x = ((ndouble)1) << shift;}
  }
  if (i < n) {
    while ((x&1) == 0) x >>= 4;
    a[i] = x >>= 1;
  }
  return(a);
}

/* initialisation alatoire */
void random_init(ndouble *a, int n) {
  int i;

  for (i=0; i < n; a[i++] = random() & mask);
}


/* compare a et b */
int compare(ndouble *a, ndouble *b, int n) {
  int i;
  for (i=n-1; (i>=0) && (a[i] == b[i]); i--);
  return((i<0) ? 0 : (a[i] > b[i]) ? 1 : -1);
}


